// this code snipit takes a 16 bit data-word and encodes it
// into a 21 bit codeword with some extra check bits embedded.
// It allows 1 bit of error correction or three bits of error detection.
// -
// although not a perfect code, it is very easy to decode on an embedded
// micro-controller.

#include <stdio.h>

int getBitSEC_ECC(unsigned short int databits, int bitPosition)
{
	        // Load the databits into an array, one bit per element.
		  unsigned char d[16];
		  unsigned char c[21];
		  unsigned short int temp;

		   unsigned short int mask = 0x0001;
		    int i,j;
		     for(i = 0; i < 16; i++)
		      {
	               temp = 0x00;	
	               temp = databits & mask; // Grab one bit.
	               mask <<= 1; // advance to the next bit in the mask.
		    // Shift the data point back to the first bit position.
		             for(j = i; j>0; j--)
		                {
		                 temp >>= 1;
		                 }
			     d[i] = temp ;
		     }


	 // Move the data bits into the appropriate codeword positions
     c[2] = d[0];
     c[4] = d[1]; c[5]=d[2]; c[6] = d[3];
     c[8] = d[4]; c[9]=d[5]; c[10]=d[6]; c[11]=d[7]; c[12]=d[8]; c[13] = d[9];
     c[14] = d[10];
     c[16] = d[11]; c[17]=d[12]; c[18]=d[13]; c[19]=d[14]; c[20]=d[15];

     // Calculate the check bits.
     
     c[0] = c[2] ^ c[4] ^ c[6] ^ c[8] ^ c[10] ^ c[12] ^ c[14] ^ c[16] ^ c[18] ^ c[20];
     c[1] = c[2] ^ c[5] ^ c[6] ^ c[9] ^ c[10] ^ c[13] ^ c[14] ^ c[17] ^ c[18];
     c[3] = c[4] ^ c[5] ^ c[6] ^ c[11]^ c[12] ^ c[13] ^ c[14] ^ c[19] ^ c[20];
     c[7] = c[8] ^ c[9] ^ c[10] ^c[11] ^ c[12] ^ c[13] ^ c[14];
     c[15] = c[16] ^ c[17] ^ c[18] ^ c[19] ^ c[20];


     for(i = 0; i < 21; i++)
     {
	     if (i == bitPosition)
		     return(c[i]);
     }
                                                                                 }

int main(int argv, char** argc)
{
 unsigned short int data = 0x0001; 
	getBitSEC_ECC(data,0);
 return (0);
}
