//Open GL tutorial, hello world.
//
//
//
//gcc -o Hello_World Hello_world.c -lX11 -lMesaGL -lMesaGLU -lMesatk -lm
//
#include <GL/glut.h>

void init(void)
{
  glClearColor(0.0,0.0,0.0,0.0);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0.0,1.0,0.0,1.0,-1.0,1.0);
}

void display(void)
{
  // clear all pixels.
  glClear(GL_COLOR_BUFFER_BIT);
  //draw green polygon (rectangle) with corners at
  //0.25, 0.25, 0.0 and 0.75, 0.75, 0.0
  glColor3f(0.0,1.0,0.0);
  glBegin(GL_POLYGON);
    glVertex3f(0.25,0.25,0.0);
    glVertex3f(0.75,0.25,0.0);
    glVertex3f(0.75,0.75, 0.0);
    glVertex3f(0.25,0.75,0.0);
  glEnd();

  glutWireSphere(0.75,25,25);

  // flush buffered GL commands...
  glFlush();
  glutSwapBuffers();
}

int main(int argc, char** argv)
{
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB);
  glutInitWindowSize(250,250);
  glutInitWindowPosition(100,100);
  glutCreateWindow("Hello World");
  init();
  glutDisplayFunc(display);
  glutMainLoop();
  return 0;
}

